uni = P2struct.uni;
bidi = P2struct.bidi;

idx = strcmp('cons',{bidi.CONDITION});  % We separate by condition. This is only applied to the bidi structure.
bidi_cons = bidi(idx);

idx = strcmp('conf',{bidi.CONDITION});
bidi_conf = bidi(idx);

[uni_A, uni_B] = dataSeparation(uni);
[bidi_cons_A, bidi_cons_B] = dataSeparation(bidi_cons);
[bidi_conf_A, bidi_conf_B] = dataSeparation(bidi_conf);

segmented_uni = dataSegmentation(uni);
segmented_uni_A = dataSegmentation(uni_A);
segmented_uni_B = dataSegmentation(uni_B);

segmented_bidi_cons = dataSegmentation(bidi_cons);
segmented_bidi_cons_A = dataSegmentation(bidi_cons_A);
segmented_bidi_cons_B = dataSegmentation(bidi_cons_B);

segmented_bidi_conf = dataSegmentation(bidi_conf);
segmented_bidi_conf_A = dataSegmentation(bidi_conf_A);
segmented_bidi_conf_B = dataSegmentation(bidi_conf_B);

filtered_uni = dataFiltering(segmented_uni);
filtered_uni_A = dataFiltering(segmented_uni_A);
filtered_uni_B = dataFiltering(segmented_uni_B);

filtered_bidi_cons = dataFiltering(segmented_bidi_cons);
filtered_bidi_cons_A = dataFiltering(segmented_bidi_cons_A);
filtered_bidi_cons_B = dataFiltering(segmented_bidi_cons_B);

filtered_bidi_conf = dataFiltering(segmented_bidi_conf);
filtered_bidi_conf_A = dataFiltering(segmented_bidi_conf_A);
filtered_bidi_conf_B = dataFiltering(segmented_bidi_conf_B);

uni_ICA = fastICA(filtered_uni,32);  % We apply the fastICA command from the pca_ica MatLab Toolbox on the 32 channels
uni_A_ICA = fastICA(filtered_uni_A,32);
uni_B_ICA = fastICA(filtered_uni_B,32);

bidi_cons_ICA = fastICA(filtered_bidi_cons,32);
bidi_cons_A_ICA = fastICA(filtered_bidi_cons_A,32);
bidi_cons_B_ICA = fastICA(filtered_bidi_cons_B,32);

bidi_conf_ICA = fastICA(filtered_bidi_conf,32);
bidi_conf_A_ICA = fastICA(filtered_bidi_conf_A,32);
bidi_conf_B_ICA = fastICA(filtered_bidi_conf_B,32);

save('P2uniICA.mat', 'uni_A_ICA', 'uni_B_ICA', 'uni_ICA')
save('P2bidiconfICA.mat', 'bidi_conf_A_ICA', 'bidi_conf_B_ICA', 'bidi_conf_ICA')
save('P2bidiconsICA.mat', 'bidi_cons_A_ICA', 'bidi_cons_B_ICA', 'bidi_cons_ICA')
