import scipy.io
import os


def open_ICA_uni():
    # We load the uni datasets
    ica = scipy.io.loadmat("P2uniICA.mat")
    return ica, ica['uni_A_ICA'], ica['uni_B_ICA']


def open_ICA_bidi_cons():
    # We load the bidi cons datasets
    ica = scipy.io.loadmat("P2bidiconsICA.mat")
    return ica['bidi_cons_ICA'], ica['bidi_cons_A_ICA'], ica['bidi_cons_B_ICA']


def open_ICA_bidi_conf():
    # We load the bidi conf datasets
    ica = scipy.io.loadmat("P2bidiconfICA.mat")
    return ica['bidi_conf_ICA'], ica['bidi_conf_A_ICA'], ica['bidi_conf_B_ICA']

def create_directory(path):
    # We check if a directory exists, and if it does not, we create it. This is useful for saving figures.
    if not os.path.exists(path):
        os.makedirs(path)
